#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>

#define SET_ADC_CH(ch) {	\
	ADMUX&=0b11111000;		\
	ADMUX|=((ch)&7);		\
	}
	
void init(){
	
	PORTB=0;
	ADMUX=(1<<REFS0);// For Aref=AVcc;
	ADCSRA=(1<<ADEN) | (1<<ADPS1)| (1<<ADPS0) | (0<<ADPS2); //Prescalar div factor =128
}

uint16_t capt(){
	//Start Single conversion
	ADCSRA|=(1<<ADSC);
	//Wait for conversion to complete
	while(!(ADCSRA & (1<<ADIF)));

   //Clear ADIF by writing one to it
   //This is standard way of clearing bits in io as said in datasheets.
   //The code writes '1' but it result in setting bit to '0' !!!

	ADCSRA|=(1<<ADIF);

	return(ADC);
}


int main(){
	
	// setam pinii portului C Si portului A ca pini de iesire
	DDRC |= (1 << PC1);
	DDRC |= (1 << PC2);
	DDRC |= (1 << PC3);
	DDRC |= (1 << PC4);
	DDRC |= (1 << PC5);
	DDRC |= (1 << PC6);
	DDRC |= (1 << PC7);
	
	DDRA |= (1 << PA0);
	DDRA |= (1 << PA1);
	
	DDRD |= (1 << PD7);
	
	PORTC = 0;
	PORTA = 0;
	PORTD = 0;
	
	DDRB &= ~(1 << PB0);  // pinul PB0 va fi input
    PORTB |= (1 << PB0);  // activam rezistenta de pull-up

	init();
	
	int val = 0;
	
	SET_ADC_CH(PB0);
	
	while (1){
		if(capt() > 0) {
			val++;
		}
		else 
			val--;
		int aux = val % 9;
		switch(aux){
		case 8:
				PORTD |= (1 << PD7);
		case 7:
				PORTA |= (1 << PA1);
		case 6:
				PORTC |= (1 << PC1);
		case 5:
				PORTC |= (1 << PC2);
		case 4:
				PORTC |= (1 << PC3);
		case 3:
				PORTC |= (1 << PC4);
		case 2:
				PORTC |= (1 << PC5);
		case 1:
				PORTC |= (1 << PC6);
		case 0:
				PORTC |= (1 << PC7);
				break;
		}
		
		_delay_ms(5000);
		PORTC &= ~(1 << PC2) & ~(1 << PC1) & ~(1 << PC3)& ~(1 << PC4)& ~(1 << PC5)& ~(1 << PC6)& ~(1 << PC7);
		PORTA &= ~(1 << PA0) & ~(1 << PA1);
		PORTD &= ~(1 << PD7);
	}
	
	return 0;
}
